#ifndef PRINT_H_
#define PRINT_H_

#include <string.h>
#include <stdint.h>

#define DEC 10
#define HEX 16
#define OCT 8
#define BIN 2

class Print
{
public:
    virtual void write(int32_t c);
    size_t write(const char *str) {
        if (str == NULL)
            return 0;
        return write((const uint8_t *) str, strlen(str));
    }
    virtual size_t write(const uint8_t *buffer, size_t size);
    size_t write(const char *buffer, size_t size) {
        return write((const uint8_t *) buffer, size);
    }

    size_t print(const char *);
    size_t print(char);
    size_t print(unsigned char, int = DEC, int = -1);
    size_t print(int, int = DEC, int = -1);
    size_t print(unsigned int, int = DEC, int = -1);
    size_t print(long, int = DEC, int = -1);
    size_t print(unsigned long, int = DEC, int = -1);
    size_t print(double, int = 2);

    size_t println(const char *);
    size_t println(char);
    size_t println(unsigned char, int = DEC, int = -1);
    size_t println(int, int = DEC, int = -1);
    size_t println(unsigned int, int = DEC, int = -1);
    size_t println(long, int = DEC, int = -1);
    size_t println(unsigned long, int = DEC, int = -1);
    size_t println(double, int = 2);
    size_t println(void);

private:
    size_t printNumber(unsigned long, int, int);
    size_t printFloat(double, int);
};

#endif /* PRINT_H_ */
